'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Switch = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _Block = require('./Block');

var Block = _interopRequireWildcard(_Block);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Switch = function Switch(props) {
  var inline = { transform: 'translateX(-' + props.active * 100 + '%)' };
  var sec = props.second || '.5s';
  var timingFunc = props.timingFunc || 'ease';
  var direction = props.direction;

  if (sec && timingFunc) inline.transition = 'all ' + timingFunc + ' ' + sec;

  var renderRowChildren = function renderRowChildren() {
    return _lodash2.default.map(props.children, function (child, i) {
      return _react2.default.createElement(
        Block.Pin,
        { top: '0px', left: i * 100 + '%', width: '100%', height: '100%', key: i },
        child
      );
    });
  };

  var renderColumnChildren = function renderColumnChildren() {
    return _lodash2.default.map(props.children, function (child, i) {
      return _react2.default.createElement(
        Block.Pin,
        { top: i * 100 + '%', left: '0px', width: '100%', height: '100%', key: i },
        child
      );
    });
  };

  return _react2.default.createElement(
    Block.Container,
    { inline: { overflow: 'hidden' } },
    _react2.default.createElement(
      Block.Container,
      { origin: true, inline: inline },
      direction === 'row' ? renderRowChildren() : renderColumnChildren()
    )
  );
};

exports.Switch = Switch;