'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.trigger = undefined;
exports.listener = listener;
exports.pipe = pipe;
exports.merge = merge;

var _jsCsp = require('js-csp');

function listener(in_chan, callback) {
  (0, _jsCsp.go)(regeneratorRuntime.mark(function _callee() {
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!true) {
              _context.next = 7;
              break;
            }

            _context.next = 3;
            return (0, _jsCsp.take)(in_chan);

          case 3:
            _context.t0 = _context.sent;
            callback(_context.t0);
            _context.next = 0;
            break;

          case 7:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));
}

var trigger = exports.trigger = {
  /*
   * type 预留给特殊情况，现阶段考虑的关键字:
   *    * Data - 传输数据，preload 承载
   *    * Error - 传输错误，preload 承载
   *    * Debug - 传输调试信息，preload 承载
   *    * Visible - 可视化通路，preload 承载
   *    * Close - 指令，preload 不承载任何数据
   */
  component: function component(_component, update_callback) {
    var base_chan = (0, _jsCsp.chan)();

    _component.componentDidUpdate = function (prevState, prevProps) {
      var action = update_callback(prevState, prevProps);
      if (action && action !== null) (0, _jsCsp.putAsync)(base_chan, action);
    };
    return base_chan;
  },
  event: function event(component, event_name, callback) {
    var base_chan = (0, _jsCsp.chan)();

    var handleEvent = function handleEvent() {
      var action = callback();
      if (action && action != null) (0, _jsCsp.putAsync)(base_chan, action);
    };

    component[event_name] = handleEvent.bind(this);

    return base_chan;
  }
};

function pipe(in_chan, xducers) {
  var out_chan = (0, _jsCsp.chan)(1, xducers);
  _jsCsp.operations.pipe(in_chan, out_chan, true);
  return out_chan;
}

function merge(chans, xducers) {
  var out_chan = (0, _jsCsp.chan)(1, xducers);
  _jsCsp.operations.pipe(_jsCsp.operations.merge(chans), out_chan, true);
  return out_chan;
}