import React from 'react'

export class Anchor extends React.Component {
  render() {
    const inline = this.props.inline || {}
    const eventFunc = this.props.eventFunc || {}

    inline.textDecoration = 'none'
    inline.color = 'currentColor'

    return (
      <a
        href={this.props.href}
        target={this.props.newTab ? '_blank' : '_self'}
        className={this.props.external}
        style={inline}
        { ...eventFunc }
      >
        { this.props.children }
      </a>
    )
  }
}

Anchor.propTypes = {
  href: React.PropTypes.string.isRequired,
  external: React.PropTypes.string,
  inline: React.PropTypes.object,
  eventFunc: React.PropTypes.object,
  newTab: React.PropTypes.bool,
}

Anchor.defaultProps = {
  external: null,
  newTab: false,
}
