import React from 'react'
import _ from 'lodash'

import * as Block from './Block'

const Switch = (props) => {
  const inline = { transform: `translateX(-${props.active * 100}%)` }
  const sec = props.second || '.5s'
  const timingFunc = props.timingFunc || 'ease'
  const direction = props.direction

  if ( sec && timingFunc ) inline.transition = `all ${timingFunc} ${sec}`

  const renderRowChildren = () => {
    return _.map(props.children, (child, i) => (
      <Block.Pin top="0px" left={`${i*100}%`} width="100%" height="100%" key={i}>{ child }</Block.Pin>
    ))
  }

  const renderColumnChildren = () => {
    return _.map(props.children, (child, i) => (
      <Block.Pin top={`${i*100}%`} left='0px' width="100%" height="100%" key={i}>{ child }</Block.Pin>
    ))
  }

  return (
    <Block.Container inline={{ overflow: 'hidden' }} >
      <Block.Container origin inline={inline} >
        { direction === 'row' ? renderRowChildren() : renderColumnChildren() }
      </Block.Container>
    </Block.Container>
  )
}

export { Switch }
