import { go, chan, takeAsync, putAsync, take, put, operations } from 'js-csp'

export function listener(in_chan, callback) {
  go(function* () {
    while(true) {
      callback(yield take(in_chan))
    }
  })
}

export const trigger = {
  /*
   * type 预留给特殊情况，现阶段考虑的关键字:
   *    * Data - 传输数据，preload 承载
   *    * Error - 传输错误，preload 承载
   *    * Debug - 传输调试信息，preload 承载
   *    * Visible - 可视化通路，preload 承载
   *    * Close - 指令，preload 不承载任何数据
   */
  component(component, update_callback) {
    const base_chan = chan()
    
    component.componentDidUpdate = (prevState, prevProps) => {
      const action = update_callback(prevState, prevProps)
      if (action && action !== null)
        putAsync(base_chan, action)
    }
    return base_chan
  },

  event(component, event_name, callback) {
    const base_chan = chan()

    const handleEvent = () => {
      const action = callback()
      if (action && action != null)
        putAsync(base_chan, action)
    }

    component[event_name] = handleEvent.bind(this)

    return base_chan
  }
}

export function pipe(in_chan, xducers) {
  const out_chan = chan(1, xducers)
  operations.pipe(in_chan, out_chan, true)
  return out_chan
}

export function merge(chans, xducers) {
  const out_chan = chan(1, xducers)
  operations.pipe(operations.merge(chans), out_chan, true)
  return out_chan
}
